#include <stdio.h>
#include <stdlib.h>

  /* Binarno potenciranje x^n.
     Test za x = 2 i n = 5, -5. */

    /* Binarno potenciranje x^n. */

double int_pow_bin(double x, int n)
{
    double pot = 1.0, b = x;
    int neg;

        /* Provjera x = 0. */
    if (x == 0.0) return 0.0;

        /* Zapamti predznak od n. */
    neg = n < 0;
    n = abs(n);

        /* Potenciranje kvadriranjem i mnozenjem. */
    while (n > 0) {
        if (n % 2 == 1) pot *= b;
        n /= 2;
        if (n > 0) b *= b;
    }

    if (neg) pot = 1.0 / pot;
    return pot;
}

int main(void)
{
    double x = 2.0;
    int n;

    n = 5;
    printf(" Potencija %g na %2d = %g\n",
           x, n, int_pow_bin(x, n) );

    n = -5;
    printf(" Potencija %g na %2d = %g\n",
           x, n, int_pow_bin(x, n) );

    return 0;
}
