  /* Zadatak 10.1.8. (str. 113)

     Napisite funkciju koja dobiva prirodni broj n i provjerava
     je li n prost (vraca 1) ili ne (vraca 0).
     Napomena: sve radimo u tipu int (ignoriramo brojeve <= 0).
  */

  /* Prva varijanta funkcije:
       - test svih mogucih netrivijalnih djelitelja izmedju 2 i n - 1.
     Sve petlje po djeliteljima su for petlje!

     Glavni program testira funkciju za zadani broj n = 1000000007.
  */

#include <stdio.h>

int prost_1(int n)
{
        /* Testira sve djelitelje od 2 do n - 1. */

    int d;    /* Potencijalni djelitelj. */

        /* Brojevi <= 1 nisu prosti (ignoriramo <= 0). */
    if (n <= 1) return 0;

        /* Petlja po svim mogucim djeliteljima od n od 2 do n - 1. */
    for (d = 2; d < n; ++d)
        if (n % d == 0) return 0;    /* Nije prost. */

    return 1;
}


int main(void)
{
    int n = 1000000007, prost;

    prost = prost_1(n);

        /* Ispis odgovora na pitanje je li broj n prost. */
    if (prost)
        printf(" Broj %d je prost\n", n);
    else
        printf(" Broj %d nije prost\n", n);

    return 0;
}
