#include <stdio.h>

  /* Rekurzivno binarno pretrazivanje. */
  /* Napomena: Ovo NIJE jako dobro = memorijski rastrosno,
     jer svaki poziv funkcije ima SVOJU kopiju adrese x i elementa elt,
     a te vrijednosti su ISTE za sve pozive. */

int binary_search(int x[], int elt, int l, int d)
{
    int i;

    if (l <= d) {
        i = (l + d) / 2;
        if (elt < x[i])
            return binary_search(x, elt, l, i - 1);
        else if (elt > x[i])
            return binary_search(x, elt, i + 1, d);
        else
            return 1;
    }
    else
        return 0;
}

int main(void)
{
    int n, elt, nasao;
    int x[] = {12, 18, 42, 44, 55, 67, 94};

    n = 7;

    printf("\n Upisi broj koji trazis u polju\n");
    scanf("%d", &elt);

    nasao = binary_search(x, elt, 0, n - 1);

    if (nasao)
        printf(" U polju x nasao element %d\n", elt);
    else
        printf(" U polju x nema elementa %d\n", elt);

    return 0;
}
