#include <stdio.h>

  /* Ubaci novi element u uzlazno sortirani niz x
     (duljine n), tako da novi niz x (duljine n+1)
     i dalje bude uzlazno sortiran. */
  /* Funkcija NE mijenja duljinu n. */

  /* Varijanta za primjenu u insertion sortu. */

void ubaci_sort(int x[], int n, int elt)
{
    int j;

    if (elt >= x[n - 1])
        x[n] = elt;
    else {    /* elt < x[n - 1] */
        j = n;
        do {
            x[j] = x[j - 1]; --j;
        } while (j >= 1 && x[j - 1] > elt);
        x[j] = elt;
    }

    return;
}

int main(void)
{
    int i, j, n;
    int x[] = {42, 12, 55, 94, 18, 44, 67};

    n = 7;

    printf("\n");
    printf(" Polazno polje x (duljine 1):\n");
    printf("   %d\n", x[0]);

        /* Petlja za sortirano ubacivanje
           sljedeceg elementa. */
    for (i = 1; i < n; ++i) {
        printf("\n");
        printf(" Ubaci x[%d] = %d.\n", i, x[i]);

            /* Ubaci x[i] u sortirano polje x
               duljine i (x[0], ..., x[i-1]). */
        ubaci_sort(x, i, x[i]);

            /* Ispis novog polja duljine i + 1. */
        printf(" Novo polje x (duljine %d):\n", i + 1);
        printf("   %d", x[0]);
        for (j = 1; j <= i; ++j)
            printf(", %d", x[j]);
        printf("\n");
    }

    return 0;
}
