#include <stdio.h>

/****************************************************************************/

  /* Selection sort algoritam (izbor ekstrema).
     Varijanta s 13. predavanja iz Prog1 (min_1a).
     Najmanji na pocetak, pamti indeks i vrijednost najmanjeg.
     Skracena zamjena bez temp.
  */

/****************************************************************************/

  /* Uzlazno sortiranje izborom ekstrema.
     Dovodimo najmanji element na pocetak.
     Pamti indeks i vrijednost najmanjeg.
     Skracena zamjena, bez temp. */

void selection_sort(int x[], int n)
{
    int i, j, ind_min, x_min;

    for (i = 0; i < n - 1; ++i) {
        ind_min = i;
        x_min = x[i];
        for (j = i + 1; j < n; ++j) {
            if (x[j] < x_min) {
                ind_min = j;
                x_min = x[j];
            }
        }
        if (i != ind_min) {
            x[ind_min] = x[i];
            x[i] = x_min;
        }
    }
      
    return;
}

/****************************************************************************/

int main(void)
{
    int i, n;
    int x[] = {42, 12, 55, 94, 18, 44, 67};

    n = 7;
    selection_sort(x, n);

    printf("\n Sortirano polje x:\n");
    for (i = 0; i < n; ++i) {
        printf(" x[%d] = %d\n", i, x[i]);
    }

    return 0;
}
