#include <stdio.h>

  /* Odgovor na pitanje: postoje li BAR DVIJE
     iste SUSJEDNE znamenke (po polozaju u zapisu)
     broja n u bazi b.
     Uociti: ako n ima samo jednu znamenku, odgovor je NE.
     Inicijalizacija je LAZ, skraceno racunanje.
     Unistava n dijeljenjem.
  */

int main(void)
{
    unsigned int b = 10, n, prva, druga, odgovor;

    printf(" Upisi nenegativni broj n: ");
    scanf("%u", &n);
    printf("\n n = %u\n", n);

    odgovor = 0;    /* NE, laz. */
    if (n >= b) {    /* Radi li i bez ovog if-a? */

            /* Prva (najniza) znamenka. */
        prva = n % b;
        n /= b;

            /* Petlja za provjeru para znamenki. */
        while (n > 0) {
            druga = n % b;
            if (prva == druga) {
                odgovor = 1;
                break;
            }
            prva = druga;    /* Pomak znamenke. */
            n /= b;
        }    /* Kraj while petlje. */
    }

    if (odgovor)
        printf(" Odgovor je DA\n");
    else
        printf(" Odgovor je NE\n");

    return 0;
}
