#include <stdio.h>

  /* Provjera je li prirodni broj palindrom.
     Usporedjuje znamenke broja u zadanoj bazi:
     prva = zadnja i druga = predzadnja i ... (tako, redom). */

int main(void)
{
    unsigned int b = 10;
    unsigned int n, pot, znam1, znam2, palindrom;

    printf(" Upisi nenegativni broj n: ");
    scanf("%u", &n);

    printf(" Broj = %u\n", n);

        /* Potencija baze uz najvisu znamenku. */
    pot = 1;
    while (n / pot >= b) {
        pot *= b;
    }
        /* Moze i ovako, praznom for naredbom:
    for (pot = 1; n / pot >= b; pot *= b);
        */

    palindrom = 1;    /* DA, istina. */

        /* Petlja za provjeru para znamenki. */
    while (n >= b) {    /* n ima bar dvije znamenke. */
        znam1 = n / pot;    /* Prva znamenka. */
        znam2 = n % b;      /* Zadnja znamenka. */
        if (znam1 != znam2) {
            palindrom = 0;
            break;
        }
        n %= pot;    /* Brisi prvu znamenku. */
        n /= b;      /* Brisi zadnju znamenku. */
        pot = pot / b / b;    /* Podijeli pot s b^2. */
    }

    if (palindrom)
        printf(" Broj JE palindrom.\n");
    else
        printf(" Broj NIJE palindrom.\n");

    return 0;
}
