#include <stdio.h>
#include <stdlib.h>

  /* Obicno potenciranje x^n.
     Test za x = 2 i n = 5, -5. */

    /* Obicno potenciranje x^n. */

double int_pow_mul(double x, int n)
{
    double pot = 1.0;
    int neg, i;

        /* Provjera x = 0. */
    if (x == 0.0) return 0.0;

        /* Zapamti predznak od n. */
    neg = n < 0;
    n = abs(n);

        /* Potenciranje mnozenjem. */
    for (i = 1; i <= n; ++i)
        pot *= x;

    if (neg) pot = 1.0 / pot;
    return pot;
}

int main(void)
{
    double x = 2.0;
    int n;

    n = 5;
    printf(" Potencija %g na %2d = %g\n",
           x, n, int_pow_mul(x, n) );

    n = -5;
    printf(" Potencija %g na %2d = %g\n",
           x, n, int_pow_mul(x, n) );

    return 0;
}
