#include <stdio.h>

/****************************************************************************/

  /* Insertion sort algoritam (sortiranje umetanjem).
     Varijanta s 13. predavanja iz Prog1 (ins_1).
     Modificirana varijanta sa SPA (Manger, knjiga, str. 147).
     Modificirana varijanta isort3 iz knjige: Jon Bentley, Programming Pearls
       [PP2_add_web.pdf, str. 159--165.].
     Sortirani dio je spijeda. Sekvencijalno trazenje prema pocetku.
     Izbjegava nepotrebna kopiranja ako je novi element najveci.
  */

/****************************************************************************/

  /* Uzlazno sortiranje (sortiranim) umetanjem.
     Sortirani dio je sprijeda.
     Ako je sljedeci element veci, ne radi nista (nema kopiranja). */

void insertion_sort(int x[], int n)
{
    int i, j, temp;

    for (i = 1; i < n; ++i)
        if (x[i] < x[i - 1]) {
            temp = x[i];
            j = i;
            do {
                x[j] = x[j - 1]; --j;
            } while (j >= 1 && x[j - 1] > temp);
            x[j] = temp;
        }

    return;
}

/****************************************************************************/

int main(void)
{
    int i, n;
    int x[] = {42, 12, 55, 94, 18, 44, 67};

    n = 7;
    insertion_sort(x, n);

    printf("\n Sortirano polje x:\n");
    for (i = 0; i < n; ++i) {
        printf(" x[%d] = %d\n", i, x[i]);
    }

    return 0;
}
